Compiling Fortran on IBMs XL

classic Classic list List threaded Threaded
3 messages Options
Reply | Threaded
Open this post in threaded view
|  
Report Content as Inappropriate

Compiling Fortran on IBMs XL

Matthias Redies
Hello,

I am trying to compile my program using this CMake script:

https://pastebin.com/zgJhbFhj

with ifort or gfortran my script works fine, but with IBMs XL Fortran I
get an error:

  > make
-- A library with BLAS API found.
-- A library with LAPACK API found.
-- MKLROOT:
-- IBM
-- DEBUG Flag -g  -C
-- Flags:   -O2 -qarch=qp -qtune=qp -ufmt_littleendian={23}
-- cmake_module_path:    /homea/jias12/jias1217/STB/cmake/Modules/
-- Configuring done
-- Generating done
-- Build files have been written to: /homea/jias12/jias1217/STB
Linking Fortran executable stb.x
/bgsys/drivers/ppcfloor/gnu-linux/powerpc64-bgq-linux/bin/ld: -f may not
be used without -shared
make[2]: *** [stb.x] Error 1
make[1]: *** [CMakeFiles/stb.x.dir/all] Error 2
make: *** [all] Error 2

I believe my Error was discussed in:

http://public.kitware.com/pipermail/cmake/2015-January/059522.html

and solved here:

http://public.kitware.com/pipermail/cmake/2015-January/059547.html

https://cmake.org/gitweb?p=cmake.git;a=commitdiff;h=4729547a

However, I am working on a cluster where the only available version is:
cmake version 2.8.12.2

In line 41&42 I tried to implement this bug fix in my script, but this
didn't work. How can I get my program to compile on version 2.8.12.2?


Kind regards


Matthias





------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
Forschungszentrum Juelich GmbH
52425 Juelich
Sitz der Gesellschaft: Juelich
Eingetragen im Handelsregister des Amtsgerichts Dueren Nr. HR B 3498
Vorsitzender des Aufsichtsrats: MinDir Dr. Karl Eugen Huthmacher
Geschaeftsfuehrung: Prof. Dr.-Ing. Wolfgang Marquardt (Vorsitzender),
Karsten Beneke (stellv. Vorsitzender), Prof. Dr.-Ing. Harald Bolt,
Prof. Dr. Sebastian M. Schmidt
------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------

--

Powered by www.kitware.com

Please keep messages on-topic and check the CMake FAQ at: http://www.cmake.org/Wiki/CMake_FAQ

Kitware offers various services to support the CMake community. For more information on each offering, please visit:

CMake Support: http://cmake.org/cmake/help/support.html
CMake Consulting: http://cmake.org/cmake/help/consulting.html
CMake Training Courses: http://cmake.org/cmake/help/training.html

Visit other Kitware open-source projects at http://www.kitware.com/opensource/opensource.html

Follow this link to subscribe/unsubscribe:
http://public.kitware.com/mailman/listinfo/cmake
Reply | Threaded
Open this post in threaded view
|  
Report Content as Inappropriate

Re: Compiling Fortran on IBMs XL

Matthias Redies
I found that by setting:

set(CMAKE_EXE_LINKER_FLAGS "-qmkshrobj")

I can include this fix for older verison.

     set(CMAKE_SHARED_LIBRARY_CREATE_Fortran_FLAGS "-qmkshrobj")

Didn't actually have any effect on the linker flags.


Kind regards


Matthias Redies


On 07.06.2017 17:02, Matthias Redies wrote:

> Hello,
>
> I am trying to compile my program using this CMake script:
>
> https://pastebin.com/zgJhbFhj
>
> with ifort or gfortran my script works fine, but with IBMs XL Fortran I
> get an error:
>
>  > make
> -- A library with BLAS API found.
> -- A library with LAPACK API found.
> -- MKLROOT:
> -- IBM
> -- DEBUG Flag -g  -C
> -- Flags:   -O2 -qarch=qp -qtune=qp -ufmt_littleendian={23}
> -- cmake_module_path:    /homea/jias12/jias1217/STB/cmake/Modules/
> -- Configuring done
> -- Generating done
> -- Build files have been written to: /homea/jias12/jias1217/STB
> Linking Fortran executable stb.x
> /bgsys/drivers/ppcfloor/gnu-linux/powerpc64-bgq-linux/bin/ld: -f may not
> be used without -shared
> make[2]: *** [stb.x] Error 1
> make[1]: *** [CMakeFiles/stb.x.dir/all] Error 2
> make: *** [all] Error 2
>
> I believe my Error was discussed in:
>
> http://public.kitware.com/pipermail/cmake/2015-January/059522.html
>
> and solved here:
>
> http://public.kitware.com/pipermail/cmake/2015-January/059547.html
>
> https://cmake.org/gitweb?p=cmake.git;a=commitdiff;h=4729547a
>
> However, I am working on a cluster where the only available version is:
> cmake version 2.8.12.2
>
> In line 41&42 I tried to implement this bug fix in my script, but this
> didn't work. How can I get my program to compile on version 2.8.12.2?
>
>
> Kind regards
>
>
> Matthias
>
>
>
>
>
> ------------------------------------------------------------------------------------------------
>
> ------------------------------------------------------------------------------------------------
>
> Forschungszentrum Juelich GmbH
> 52425 Juelich
> Sitz der Gesellschaft: Juelich
> Eingetragen im Handelsregister des Amtsgerichts Dueren Nr. HR B 3498
> Vorsitzender des Aufsichtsrats: MinDir Dr. Karl Eugen Huthmacher
> Geschaeftsfuehrung: Prof. Dr.-Ing. Wolfgang Marquardt (Vorsitzender),
> Karsten Beneke (stellv. Vorsitzender), Prof. Dr.-Ing. Harald Bolt,
> Prof. Dr. Sebastian M. Schmidt
> ------------------------------------------------------------------------------------------------
>
> ------------------------------------------------------------------------------------------------
>
>

--

Powered by www.kitware.com

Please keep messages on-topic and check the CMake FAQ at: http://www.cmake.org/Wiki/CMake_FAQ

Kitware offers various services to support the CMake community. For more information on each offering, please visit:

CMake Support: http://cmake.org/cmake/help/support.html
CMake Consulting: http://cmake.org/cmake/help/consulting.html
CMake Training Courses: http://cmake.org/cmake/help/training.html

Visit other Kitware open-source projects at http://www.kitware.com/opensource/opensource.html

Follow this link to subscribe/unsubscribe:
http://public.kitware.com/mailman/listinfo/cmake
Reply | Threaded
Open this post in threaded view
|  
Report Content as Inappropriate

Re: Compiling Fortran on IBMs XL

Bill Hoffman
On 6/8/2017 5:13 AM, Matthias Redies wrote:

>
> I believe my Error was discussed in:
>
> http://public.kitware.com/pipermail/cmake/2015-January/059522.html
>
> and solved here:
>
> http://public.kitware.com/pipermail/cmake/2015-January/059547.html
>
> https://cmake.org/gitweb?p=cmake.git;a=commitdiff;h=4729547a
>
> However, I am working on a cluster where the only available version is:
> cmake version 2.8.12.2
You should be able to build cmake from source or download a linux binary
from here: https://cmake.org/download/.

It does not need to be installed as root, you can just untar and run
cmake from any directory.  If I was in your  position I would set the
minimum required version of cmake to one that handles your fortran
compiler.  Then use the binary or build from source.

-Bill
--

Powered by www.kitware.com

Please keep messages on-topic and check the CMake FAQ at: http://www.cmake.org/Wiki/CMake_FAQ

Kitware offers various services to support the CMake community. For more information on each offering, please visit:

CMake Support: http://cmake.org/cmake/help/support.html
CMake Consulting: http://cmake.org/cmake/help/consulting.html
CMake Training Courses: http://cmake.org/cmake/help/training.html

Visit other Kitware open-source projects at http://www.kitware.com/opensource/opensource.html

Follow this link to subscribe/unsubscribe:
http://public.kitware.com/mailman/listinfo/cmake
Loading...